/* Tecnisa - Tecnologia em Informtica

 Descrio:
 Procedimento para execuo da procedure de Movimentao de Estoque

 Criao:
 25/01/05 - Alessandra Cristina

 @C:\Win_V4\Sql\End_Conv\Oracle\4010_ESTSTPO_MovimentacaoFil.SQL
 RAISERROR('' , True);
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'MOVIMENTACAO_FIL' AND
                 TYPE = 'P' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP PROCEDURE MOVIMENTACAO_FIL
GO

CREATE PROCEDURE MOVIMENTACAO_FIL @P_FILIAL          VARCHAR(50),
                                  @P_CDALMOXARIFE    VARCHAR(06),
                                  @P_CDLOCALESTOQ    VARCHAR(06),
                                  @P_NRLOTEESTQ      VARCHAR(20),
                                  @P_TAMNIVEL        INTEGER,
                                  @P_DTINICIAL       DATETIME,
                                  @P_DTFINAL         DATETIME,
                                  @P_PRODINI         VARCHAR(20),
                                  @P_PRODFIM         VARCHAR(20),
                                  @P_IDLANCTO        INTEGER,
                                  @P_IDCUSTO         INTEGER,
                                  @P_NRLISTA         VARCHAR(10),
                                  @P_MOVCONSOLID     VARCHAR(1) = 'N',
                                  @P_CUSTOALMOX      VARCHAR(1) = 'N'
AS
   DECLARE  @V_NRFILIAL       VARCHAR(20); -- Cdigo gerado para cada filial
   DECLARE  @V_DELMOVIMEN     VARCHAR(1);
   DECLARE  @V_CDFILIAL       VARCHAR(04);
   DECLARE  @V_IDUTILALMOX    VARCHAR(1);
   DECLARE  @V_IDUTILLCESTQ   VARCHAR(1);
   DECLARE  @V_CDALMOXARIFE   VARCHAR(06);
   DECLARE  @V_CDLOCALESTOQ   VARCHAR(06);
BEGIN
   SET @V_IDUTILALMOX   = NULL;
   SET @V_IDUTILLCESTQ  = NULL;
   SET @V_NRFILIAL      = NULL;

   SET @V_DELMOVIMEN = 'S';

   DECLARE C_FILIAL CURSOR FOR
      SELECT CDFILIAL
      FROM FILIAL
      WHERE ((CHARINDEX('_'+CDFILIAL+'_', @P_FILIAL) > 0) OR (@P_FILIAL = 'T'));

   OPEN C_FILIAL;

   FETCH NEXT FROM C_FILIAL INTO @V_CDFILIAL;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_DELMOVIMEN = 'N';
      SELECT @V_IDUTILALMOX = MAX(IDUTILALMOX),
             @V_IDUTILLCESTQ = MAX(IDUTILLCESTQ)
      FROM PARAMFILIAL
      WHERE CDFILIAL = @V_CDFILIAL;

      EXEC TEKNISA.NOVO_CODIGO 'MOVIESTOQUE', @P_SEQUENCIAL = @V_NRFILIAL OUTPUT;
      SET @V_NRFILIAL = SUBSTRING(@V_NRFILIAL, 11, 10);

      INSERT INTO LISTA
         (NRLISTA, CDLISTA)
      VALUES
         (@P_NRLISTA , @V_NRFILIAL);

      IF (@V_IDUTILALMOX = 'S') BEGIN
         DECLARE C_ALMOXARIFE CURSOR FOR
            SELECT CDALMOXARIFE
            FROM ALMOXARIFADO
            WHERE (CDFILIAL  = @V_CDFILIAL)      AND
                  ((CHARINDEX('_'+@V_CDFILIAL+CDALMOXARIFE+'_', @P_CDALMOXARIFE) > 0)
                  OR (@P_CDALMOXARIFE = 'T'))

         OPEN C_ALMOXARIFE;

         FETCH NEXT FROM C_ALMOXARIFE INTO @V_CDALMOXARIFE;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_IDUTILLCESTQ = 'S') BEGIN
               DECLARE C_LOCALESTOQ CURSOR FOR
                  SELECT CDLOCALESTOQ
                  FROM LOCALESTOQUE
                  WHERE (CDFILIAL     = @V_CDFILIAL)        AND
                        (CDALMOXARIFE = @V_CDALMOXARIFE)    AND
                        ((CHARINDEX('_'+@V_CDFILIAL+@V_CDALMOXARIFE+CDLOCALESTOQ+'_', @P_CDLOCALESTOQ) > 0)
                        OR (@P_CDLOCALESTOQ = 'T'))

               OPEN C_LOCALESTOQ;
               FETCH NEXT FROM C_LOCALESTOQ INTO @V_CDLOCALESTOQ;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                   EXEC TEKNISA.MOVIMENTACAO_ESTOQUE @V_CDFILIAL,   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, '', @P_TAMNIVEL, @P_DTINICIAL,
                                                     @P_DTFINAL,    @P_PRODINI, @P_PRODFIM, @P_IDLANCTO,  @P_IDCUSTO,  @V_NRFILIAL,  'N',
                                                    @P_CUSTOALMOX, @V_DELMOVIMEN;


                  FETCH NEXT FROM C_LOCALESTOQ INTO @V_CDLOCALESTOQ;
               END;
               CLOSE C_LOCALESTOQ;
               DEALLOCATE C_LOCALESTOQ;
            END
            ELSE BEGIN
               EXEC TEKNISA.MOVIMENTACAO_ESTOQUE @V_CDFILIAL, @V_CDALMOXARIFE, '', '', @P_TAMNIVEL, @P_DTINICIAL,
                                                 @P_DTFINAL,  @P_PRODINI, @P_PRODFIM,  @P_IDLANCTO, @P_IDCUSTO, @V_NRFILIAL,
                                                 'N', @P_CUSTOALMOX, @V_DELMOVIMEN;
            END;
            FETCH NEXT FROM C_ALMOXARIFE INTO @V_CDALMOXARIFE;
         END;
         CLOSE C_ALMOXARIFE;
         DEALLOCATE C_ALMOXARIFE;
      END
      ELSE BEGIN
         EXEC TEKNISA.MOVIMENTACAO_ESTOQUE @V_CDFILIAL, '', '', '', @P_TAMNIVEL, @P_DTINICIAL,
                                           @P_DTFINAL, @P_PRODINI,  @P_PRODFIM,  @P_IDLANCTO, @P_IDCUSTO,
                                           @V_NRFILIAL,  'N', @P_CUSTOALMOX, @V_DELMOVIMEN;
      END;
      FETCH NEXT FROM C_FILIAL INTO @V_CDFILIAL;
   END;
   CLOSE C_FILIAL;
   DEALLOCATE C_FILIAL;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'MOVIMENTACAO_FIL','5.03.007';
GO

